/*
 * |-----------------------------------------------------------|
 * | Copyright (c) 1991, 1990 MIPS Computer Systems, Inc.      |
 * | All Rights Reserved                                       |
 * |-----------------------------------------------------------|
 * |          Restricted Rights Legend                         |
 * | Use, duplication, or disclosure by the Government is      |
 * | subject to restrictions as set forth in                   |
 * | subparagraph (c)(1)(ii) of the Rights in Technical        |
 * | Data and Computer Software Clause of DFARS 252.227-7013.  |
 * |         MIPS Computer Systems, Inc.                       |
 * |         950 DeGuigne Avenue                               |
 * |         Sunnyvale, California 94088-3650, USA             |
 * |-----------------------------------------------------------|
 */
#ident	"$Header: wctomb.c,v 1.2.2.1 92/06/24 14:01:12 marker Exp $"

/*	Copyright (c) 1984, 1986, 1987, 1988 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/


#include <ctype.h>
#include <stdlib.h>
#define multibyte       (_ctype[520]>1)
#define eucw1   _ctype[514]
#define eucw2   _ctype[515]
#define eucw3   _ctype[516]
#define EUCMASK 0x30000000
#define P00     0x00000000      /* Code Set 0 */
#define P11     0x30000000      /* Code Set 1 */
#define P01     0x10000000      /* Code Set 2 */
#define P10     0x20000000      /* Code Set 3 */
#define SS2     0x8e
#define SS3     0x8f
/* start for MNLS 3.2 by AT&T UP  Nov.16,1988 */
/*
 *	The followings are for 2 bytes of multi-byte code definition.
 */
#define H_EUCMASK 0x8080	/* mask bit for 16 bits */
#define H_P00     0x0000	/* Code Set 0 for 2 bytes code */
#define H_P11     0x8080	/* Code Set 1 for 2 bytes code */
#define H_P01     0x0080	/* Code Set 2 for 2 bytes code */
#define H_P10     0x8000	/* Code Set 3 for 2 bytes code */
/* end for MNLS 3.2 */

int wctomb(s, wchar)
char *s;
wchar_t wchar;
{
        char *olds = s;
        register int size, index;
        unsigned char d;
/* start for MNLS 3.2 by AT&T UP  Nov.16,1988 */
	short	pcw;	/* process code width */
/* end for MNLS 3.2 */
        if(!s)
                return(0);
        if(!multibyte || wchar <= 0177 || wchar <= 0377 && iscntrl(wchar)) {
                *s++ = (char)wchar;
                return(1);
        }
/* start for MNLS 3.2 by AT&T UP  Nov.16,1988 */
	if ( eucw1 > sizeof(unsigned short) ||
	     eucw2 > sizeof(unsigned short) ||
	     eucw3 > sizeof(unsigned short))
		pcw = sizeof(unsigned long);	/* 32 bits process code */
	else
		pcw = sizeof(unsigned short);	/* 16 bits process code */
/* end for MNLS 3.2 */
/* start for MNLS 3.2 by AT&T UP  Nov.16,1988 */
	if (pcw > sizeof(unsigned short)) {
        switch(wchar & EUCMASK) {
                
                case P11:
                        size = eucw1;
                        break;
                
                case P01:
                        *s++ = (char)SS2;
                        size = eucw2;
                        break;
                
                case P10:
                        *s++ = (char)SS3;
                        size = eucw3;
                        break;
                
                default:
                        return(-1);
        }
	} else {
        switch(wchar & H_EUCMASK) {
                
                case H_P11:
                        size = eucw1;
                        break;
                
                case H_P01:
                        *s++ = (char)SS2;
                        size = eucw2;
                        break;
                
                case H_P10:
                        *s++ = (char)SS3;
                        size = eucw3;
                        break;
                
                default:
                        return(-1);
        }
	}
/* end for MNLS 3.2 */
        if((index = size) <= 0)
                return -1;      
        while(index--) {
                d = wchar | 0200;
/* start for MNLS 3.2 by AT&T UP  Nov.16,1988 */
/*              wchar >>= 7; */
		if (pcw > sizeof(unsigned short))
                	wchar >>= 7;
		else
	                wchar >>= 8;
/* end for MNLS 3.2 */
                if(iscntrl(d))
                        return(-1);
                s[index] = d;
        }
        return(s + size - olds);
}
